//[Nip] Add laser sites to night vision goggles.
// by BionicNipple (bionic.nipple@gmail.com)
//
// note 1: the "end map nvg" event isn't used by this script, but
//         I put some endon()s in for it, so mods that handle nvg
//         lasers themself can disable this map's nvg. e.g.:
//             level notify("end map nvg");
// note 2: additionally a server can disable the nvg lasers (if they
//         conflict with a mod or they just don't like them) with
//         a cvar, sorry, a dvar. e.g.:
//             set mp_treasure_lasers "0"

init(){
	if (getdvar("mp_treasure_lasers") == "0") return; //[Nip] see note 2
	thread onPlayerConnect();
}

onPlayerConnect(){
	level endon("end map nvg"); //[Nip] See note 1 above
	while (true){
		level waittill("connecting", player);
		
		player thread onPlayerSpawn();
	}
}

onPlayerSpawn(){
	level endon("end map nvg"); //[Nip] See note 1 above
	while (true){
		self waittill("spawned_player");
		
		self thread monitor_nvg();
	}
}


monitor_nvg(){
	self endon("spawned_player");
	level endon("end map nvg"); //[Nip] See note 1 above
	
	self laserOff(); //[Nip] In case it was left on for some reason
	while (true){
		self waittill("night_vision_on");
		self laserOn();
		self waittill("night_vision_off");
		self laserOff();
	}
}

//[Nip] Yes, lasers really are this easy.
laserOn(val){
	self setclientdvar("cg_laserforceon", "1");
	self setclientdvar("cg_laserlight", "1");
	self setclientdvar("cg_laserRadius", "0.5");
	self setclientdvar("cg_laserlightRadius", "1");	
}

laserOff(val){
	self setclientdvar("cg_laserforceon", "0");
}